//
//  WatchSessionDelegate.m
//  ObjectiveCWCSessionTest
//
//  Created by John Schroeder on 11/22/19.
//  Copyright © 2019 John Schroeder. All rights reserved.
//

#import "WatchSessionDelegate.h"

@implementation WatchSessionDelegate

+ (id)instance {
    static WatchSessionDelegate *sharedInstance = nil;
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        sharedInstance = [[self alloc] init];
    });
    return sharedInstance;
}

- (void)session:(WCSession *)session activationDidCompleteWithState:(WCSessionActivationState)activationState error:(NSError *)error {
    printf("activationDidCompleteWithState\n");
}

- (void)session:(WCSession *)session didReceiveMessage:(NSDictionary<NSString *,id> *)message {
     printf("didReceiveMessage\n");
}

- (void)session:(WCSession *)session didReceiveMessage:(NSDictionary<NSString *,id> *)message replyHandler:(void (^)(NSDictionary<NSString *,id> * _Nonnull))replyHandler {
    printf("didReceiveMessage (with reply handler)\n");
    if (replyHandler) {
        NSArray* keys = [NSArray arrayWithObjects:@"testReplyKey", nil];
        NSArray* values = [NSArray arrayWithObjects:@"testReplyValue", nil];
        NSDictionary* dict = [[NSDictionary alloc] initWithObjects:values forKeys:keys];
        
        replyHandler(dict);
    }
}

- (void)sessionDidBecomeInactive:(nonnull WCSession *)session {
    printf("sessionDidBecomeInactive\n");
}


- (void)sessionDidDeactivate:(nonnull WCSession *)session {
    printf("sessionDidDeactivate\n");
}

@end
