﻿using System;
using Foundation;
using ObjCRuntime;
using WatchConnectivity;

namespace WatchWCSessionApp.WatchOSExtension
{
    public class OnWatchWatchSessionDelegate : WCSessionDelegate
    {
        #region Sincleton/Constructor
        public static OnWatchWatchSessionDelegate Instance { get; private set; } = new OnWatchWatchSessionDelegate();

        private OnWatchWatchSessionDelegate()
        {
            Console.WriteLine("In OnWatchWatchSessionDelegate constructor");
        }
        #endregion

        #region WCSessionDelegate overrides
        public override void ActivationDidComplete(WCSession session, WCSessionActivationState activationState, Foundation.NSError error)
        {
            Console.WriteLine("OnWatchWatchSessionDelegate->ActivationDidComplete(...) called");
        }

        public override void SessionReachabilityDidChange(WCSession session)
        {
            Console.WriteLine("OnWatchWatchSessionDelegate->SessionReachabilityDidChange(...) called");
        }

        public override void DidReceiveMessage(WCSession session, NSDictionary<NSString, NSObject> message, WCSessionReplyHandler replyHandler)
        {
            Console.WriteLine("OnWatchWatchSessionDelegate->DidReceiveMessage(...) called");

            if (message != null && message.Keys.Length > 0)
            {
                var key = message.Keys[0];
                var value = message[key];
                Console.WriteLine("Message received on watch: key = {0}, value = {1}", key, value);
            }
            else
            {
                Console.WriteLine("ERROR: Bad message received");
            }

            if (replyHandler != null)
            {
                Console.WriteLine("Reply handler is not null");

                NSString[] keys = { new NSString("testReplyHandlerKey") };
                NSObject[] values = { new NSString("testReplyHandlerValue") };
                var dict = new NSDictionary<NSString, NSObject>(keys, values);

                replyHandler(dict);
            }
            else
            {
                Console.WriteLine("ERROR: Reply handler is null");
            }
        }
        #endregion
    }
}
